"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Migration = void 0;
// At this moment only support "mysql"
var Migration = /** @class */ (function () {
    function Migration(config) {
        this.config = config;
        this.validateConfig();
    }
    Migration.prototype.validateConfig = function () {
        if (!this.config || !this.config.migrations) {
            throw new Error("Config and at least one migration must be defined.");
        }
        !this.config.name && (this.config.name = "Default Name");
        !this.config.directory && (this.config.directory = "migrations");
    };
    Migration.prototype.validateMigration = function (_a) {
        var type = _a.type, host = _a.host, port = _a.port, password = _a.password, database = _a.database, user = _a.user, extension = _a.extension, file = _a.file, folder = _a.folder, _b = _a.migrationName, migrationName = _b === void 0 ? "Default Migration" : _b, recursive = _a.recursive;
        if (type !== "mysql") {
            throw new Error("Only support mysql like migration type.");
        }
        if (!host) {
            throw new Error("You must define a migration URL or a migration HOST.");
        }
        return {
            database: database,
            port: port,
            password: password,
            host: host,
            user: user,
            type: type,
            extension: extension,
            file: file,
            folder: folder,
            migrationName: migrationName,
            recursive: recursive,
        };
    };
    Migration.prototype.toPrimitives = function () {
        var _this = this;
        var _a, _b;
        if (!((_b = (_a = this.config) === null || _a === void 0 ? void 0 : _a.migrations) === null || _b === void 0 ? void 0 : _b.length)) {
            throw new Error("Config and at least one migration must be defined.".red);
        }
        return this.config.migrations.map(function (migration) {
            return _this.validateMigration(migration.migration);
        });
    };
    return Migration;
}());
exports.Migration = Migration;
